<top>
    <div id="wrapper" class="top">
        <!-- Sidebar -->
        <div id="sidebar-wrapper">
            <ul id="menuList" class="sidebar-nav">
                <li class="sidebar-brand">
                    <a href="#"><span class="brand-text">CloudGPS3</span><span id="main_icon"><img src="assets/images/GPSDBrogo6-3.png"></span></a>
                </li>
                <li each="{menu in props.menus}">
                    <a onclick="{ menu.onclick }" class="menuLink {menu.name} { menu.selectedMenu} ">
                        <span if="{ menu.icon.indexOf('glyphicon') == -1 }" class="sub_icon rt {menu.icon}"></span>{menu.title}
                        <span if="{ menu.icon.indexOf('glyphicon') != -1 }" class="sub_icon glyphicon {menu.icon}"></span>
                    </a>
                </li>
            </ul>
        </div>
        <!-- /#sidebar-wrapper -->
        <!-- Page Content -->
        <div id="page-content-wrapper">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-lg-12">
                        <!-- Tov Nav -->
                        <nav role="navigation" class="navbar navbar-default" >
                            <div class="navbar-header">
                                <button type="button" data-target="#navbarCollapse" data-toggle="collapse" class="navbar-toggle">
                                    <span class="sr-only">Toggle navigation</span>
                                    <span class="icon-bar"></span>
                                    <span class="icon-bar"></span>
                                    <span class="icon-bar"></span>
                                </button>
                                <a id="menuclick" class="navbar-brand">
                                    <span class="glyphicon glyphicon-menu-hamburger"></span>
                                    <span class="brand-text" >{ title }</span>
                                </a>
                                <div class="messageArea">
                                    <div id="errorMessage" class="messageWidth alert alert-danger nav navbar-nag alert-dismissible datatablesAlert" role="alert" style="display: none">
                                        <button type="button" class="close" data-dismiss="alert" aria-label="閉じる"><span>×</span></button>
                                    </div>
                                    <div id="successMessage" class="messageWidth alert alert-success nav navbar-nag alert-dismissible datatablesAlert" role="alert" style="display: none">
                                        <button type="button" class="close" data-dismiss="alert" aria-label="閉じる"><span>×</span></button>
                                    </div>
                                </div>
                            </div>
                            <div id="navbarCollapse" class="collapse navbar-collapse">
                                <ul class="nav navbar-nav pull-right pr20">
                                    <li class="dropdown">
                                        <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                                            <img if="{ state.isImg == true}" src="{ state.icon }" style="height: 20px;"/>
                                            <span if="{ state.isImg == false}" class="glyphicon { state.icon }"></span>
                                            <span class="user-name">{state.email}</span>
                                            <b class="caret"></b>
                                        </a>
                                        <ul class="dropdown-menu">
                                            <li><a onclick="{onLogoutClick}">ログアウト</a></li>
                                        </ul>
                                    </li>
                                    <li><a onclick="{onLogoutClick}"><span class="glyphicon glyphicon-log-out"></span></a></li>
                                </ul>
                            </div>
                        </nav>
                    </div>
                </div>
                <div class="row" >
                    <div class="col-lg-12 panel-inner">
                        <div class="panel panel-default" >
                            <admincontent/>
                        </div>
                    </div>
                </div>
                <footer id ="footer">
                    <span>Copyright © 2022 CloudGPS3 { "v" + state.version }</span>
                </footer>
            </div>
        </div>
    </div>
    <commonmodal/>
    <script>
        export default {
            onBeforeMount(props, state) {
                this.loading = props.loading,
                this.logoutModal = props.logoutModal
                this.title = "CloudGPS3管理画面"
            },
            onMounted(props, state) {

                document.title = this.title

                // アイコン表示
                // const icon = UserInfo.getInstance().getIcon()
                // const isImg = true
                // if (icon && icon.indexOf("glyphicon") > -1) {
                //     isImg = false
                // }

                // サイドバー
                $("#menuclick").on('click', function(e) {
                    e.preventDefault()
                    $("#wrapper").toggleClass("locked")
                })

                if(!$("#wrapper").hasClass("locked")){
                    $("#sidebar-wrapper").hover(function(e) {
                        e.preventDefault()
                        $("#wrapper").toggleClass("toggled")
                        $("#sidebar-wrapper").toggleClass("scroll")
                    })
                }

                // メニューのoncllick
                props.menus.forEach(menu => {
                    menu.onclick = this.getOnClick(menu.name)
                    const currentContent = localStorage.getItem(Const.LOCAL_STORAGE_KEY_CURRENT_CONTENT)
                    if (!currentContent) return

                    const localStorageMenu = JSON.parse(currentContent).param && JSON.parse(currentContent).param.name ? JSON.parse(currentContent).param.name : JSON.parse(currentContent).name
                    if (menu.name == localStorageMenu) {
                        menu.selectedMenu = 'selectedMenu'
                    }
                })

                const region = location.origin.indexOf('admin.cloudgps.io') > -1 ? 'a' : 'b'

                this.update({
                    email: UserInfo.getInstance().getGroupId() ? UserInfo.getInstance().getGroupId() : UserInfo.getInstance().getEmail(),
                    version: Settings.getValue('version') + region
                })

                let lastContent = localStorage.getItem(Const.LOCAL_STORAGE_KEY_CURRENT_CONTENT)
                if (!lastContent) return

                Function.prototype.toJSON = Function.prototype.toString
                const parser = function(k,v){
                    if (!v) return ""
                    return v.toString().indexOf('function') === 0 ? eval('('+v+')') : v
                }
                lastContent = JSON.parse(lastContent)
                if (lastContent) {
                    const content = lastContent.name
                    const param = lastContent.param
                    param.loading = props.loading
                    param.logoutModal = props.logoutModal
                    param.scrutiny = this.scrutiny
                    // this.update({
                    //     menuTitle: i18next.t("datatables." + lastContent.name + ".title")
                    // })
                    if (param && param.name) {
                        param.service = this.getService(param.name)
                        this.update({
                            // menuTitle: i18next.t("datatables." + param.name + ".title")
                        })
                        riot.mount('admincontent', param, param.name)
                    } else {
                        riot.mount('admincontent', param, content)
                    }
                }
            },
            onBaseClick(e, name) {
                if (e) {
                    this.ctrlMenuClass(e.currentTarget)
                }
                RiotUtil.next('admincontent', {
                    scrutiny: this.scrutiny,
                    logoutModal: this.logoutModal
                }, name)
            },
            onLogoutClick(e) {
                location.href = window.location.href.replace(/#.*$/,"");
            },
            onUserClick(e) {
                this.onBaseClick(e, "user")
            },
            onAssetClick(e) {
                this.onBaseClick(e, "asset")
            },
            onUserAssetClick(e) {
                this.onBaseClick(e, "user_asset")
            },
            onCaseClick(e) {
                this.onBaseClick(e, "case")
            },
            onOrderClick(e) {
                this.onBaseClick(e, "order")
            },
            onRealtimeClick(e) {
                this.onBaseClick(e, "realtime")
            },
            onExtOrderClick(e) {
                this.onBaseClick(e, "extorder")
            },
            onSearchTrackClick(e) {
                this.onBaseClick(e, "searchtrack")
            },
            onTracksClick(e) {
                this.onBaseClick(e, "tracks")
            },
            onQuestionnaireClick(e) {
                this.onBaseClick(e, "questionnaire")
            },
            onCodeClick(e) {
                this.onBaseClick(e, "code")
            },
            onAggregateClick(e) {
                this.onBaseClick(e, "aggregate")
            },
            onErrorClick(e) {
                this.onBaseClick(e, "error")
            },
            onBlacklistClick(e) {
                this.onBaseClick(e, "blacklist")
            },
            onMailHistoryClick(e) {
                this.onBaseClick(e, "mailhistory")
            },
            getService(name) {
                switch(name) {
                    case 'user':
                        return new UserService()
                    case 'asset':
                        return new AssetService()
                    case 'user_asset':
                        return new AssetService()
                    case 'case':
                        return new CaseService()
                    case 'order':
                        return new OrderService()
                    case 'realtime':
                        return new RealtimeService()
                    case 'extorder':
                        return new ExtOrderService()
                    case 'searchtrack':
                    case 'tracks':
                        return new TrackService()
                    case 'questionnaire':
                        return new QuestionnaireService()
                    case 'code':
                        return new CodeService()
                    case 'aggregate':
                        return new AggregateService()
                    case 'error':
                        return new ErrorService()
                    case 'blacklist':
                        return new BlacklistService()
                    case 'mailhistory':
                        return new MailHistoryService()
                }
            },
            getOnClick(name) {
                switch(name) {
                    case 'user':
                        return this.onUserClick
                    case 'asset':
                        return this.onAssetClick
                    case 'user_asset':
                        return this.onUserAssetClick
                    case 'case':
                        return this.onCaseClick
                    case 'order':
                        return this.onOrderClick
                    case 'realtime':
                        return this.onRealtimeClick
                    case 'extorder':
                        return this.onExtOrderClick
                    case 'searchtrack':
                        return this.onSearchTrackClick
                    case 'tracks':
                        return this.onTracksClick
                    case 'questionnaire':
                        return this.onQuestionnaireClick
                    case 'code':
                        return this.onCodeClick
                    case 'aggregate':
                        return this.onAggregateClick
                    case 'error':
                        return this.onErrorClick
                    case 'blacklist':
                        return this.onBlacklistClick
                    case 'mailhistory':
                        return this.onMailHistoryClick
                }
            },
            ctrlMenuClass(target) {
                $(target).parents().find('#menuList li a.menuLink').removeClass('selectedMenu')
                $(target).addClass('selectedMenu')
            },
            scrutiny(value) {
                if (Number.isInteger(value)) return value
                if (!value) return ''
                return value.replace(/\s+/g, "") ? value.replace(/\s+/g, "") : ''
            }
        }
    </script>
</top>